/* ***********************************************************
 * This file was automatically generated on 2020-01-22.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

/**
 * Measures IAQ index, temperature, humidity and air pressure
 */
public class BrickletAirQuality extends Device {
	public final static int DEVICE_IDENTIFIER = 297;
	public final static String DEVICE_DISPLAY_NAME = "Air Quality Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletairquality", DEVICE_IDENTIFIER, BrickletAirQuality.class, BrickletAirQualityActions.class, "2.0.5");

	public final static byte FUNCTION_GET_ALL_VALUES = (byte)1;
	public final static byte FUNCTION_SET_TEMPERATURE_OFFSET = (byte)2;
	public final static byte FUNCTION_GET_TEMPERATURE_OFFSET = (byte)3;
	public final static byte FUNCTION_SET_ALL_VALUES_CALLBACK_CONFIGURATION = (byte)4;
	public final static byte FUNCTION_GET_ALL_VALUES_CALLBACK_CONFIGURATION = (byte)5;
	public final static byte FUNCTION_GET_IAQ_INDEX = (byte)7;
	public final static byte FUNCTION_SET_IAQ_INDEX_CALLBACK_CONFIGURATION = (byte)8;
	public final static byte FUNCTION_GET_IAQ_INDEX_CALLBACK_CONFIGURATION = (byte)9;
	public final static byte FUNCTION_GET_TEMPERATURE = (byte)11;
	public final static byte FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION = (byte)12;
	public final static byte FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION = (byte)13;
	public final static byte FUNCTION_GET_HUMIDITY = (byte)15;
	public final static byte FUNCTION_SET_HUMIDITY_CALLBACK_CONFIGURATION = (byte)16;
	public final static byte FUNCTION_GET_HUMIDITY_CALLBACK_CONFIGURATION = (byte)17;
	public final static byte FUNCTION_GET_AIR_PRESSURE = (byte)19;
	public final static byte FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION = (byte)20;
	public final static byte FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION = (byte)21;
	public final static byte FUNCTION_REMOVE_CALIBRATION = (byte)23;
	public final static byte FUNCTION_SET_BACKGROUND_CALIBRATION_DURATION = (byte)24;
	public final static byte FUNCTION_GET_BACKGROUND_CALIBRATION_DURATION = (byte)25;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_ALL_VALUES = 6;
	private final static int CALLBACK_IAQ_INDEX = 10;
	private final static int CALLBACK_TEMPERATURE = 14;
	private final static int CALLBACK_HUMIDITY = 18;
	private final static int CALLBACK_AIR_PRESSURE = 22;

	public final static int ACCURACY_UNRELIABLE = 0;
	public final static int ACCURACY_LOW = 1;
	public final static int ACCURACY_MEDIUM = 2;
	public final static int ACCURACY_HIGH = 3;
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int DURATION_4_DAYS = 0;
	public final static int DURATION_28_DAYS = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<AllValuesListener> listenerAllValues = new CopyOnWriteArrayList<AllValuesListener>();
	private List<IAQIndexListener> listenerIAQIndex = new CopyOnWriteArrayList<IAQIndexListener>();
	private List<TemperatureListener> listenerTemperature = new CopyOnWriteArrayList<TemperatureListener>();
	private List<HumidityListener> listenerHumidity = new CopyOnWriteArrayList<HumidityListener>();
	private List<AirPressureListener> listenerAirPressure = new CopyOnWriteArrayList<AirPressureListener>();

	public class AllValues {
		public int iaqIndex;
		public int iaqIndexAccuracy;
		public int temperature;
		public int humidity;
		public int airPressure;

		public String toString() {
			return "[" + "iaqIndex = " + iaqIndex + ", " + "iaqIndexAccuracy = " + iaqIndexAccuracy + ", " + "temperature = " + temperature + ", " + "humidity = " + humidity + ", " + "airPressure = " + airPressure + "]";
		}
	}

	public class AllValuesCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class IAQIndex {
		public int iaqIndex;
		public int iaqIndexAccuracy;

		public String toString() {
			return "[" + "iaqIndex = " + iaqIndex + ", " + "iaqIndexAccuracy = " + iaqIndexAccuracy + "]";
		}
	}

	public class IAQIndexCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + "]";
		}
	}

	public class TemperatureCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class HumidityCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class AirPressureCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletAirQuality#setAllValuesCallbackConfiguration(long, boolean)}.
	 * 
	 * The parameters are the same as {@link BrickletAirQuality#getAllValues()}.
	 */
	public interface AllValuesListener extends DeviceListener {
		public void allValues(int iaqIndex, int iaqIndexAccuracy, int temperature, int humidity, int airPressure);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletAirQuality#setIAQIndexCallbackConfiguration(long, boolean)}.
	 * 
	 * The parameters are the same as {@link BrickletAirQuality#getIAQIndex()}.
	 */
	public interface IAQIndexListener extends DeviceListener {
		public void iaqIndex(int iaqIndex, int iaqIndexAccuracy);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletAirQuality#setTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletAirQuality#getTemperature()}.
	 */
	public interface TemperatureListener extends DeviceListener {
		public void temperature(int temperature);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletAirQuality#setHumidityCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletAirQuality#getHumidity()}.
	 */
	public interface HumidityListener extends DeviceListener {
		public void humidity(int humidity);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletAirQuality#setAirPressureCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletAirQuality#getAirPressure()}.
	 */
	public interface AirPressureListener extends DeviceListener {
		public void airPressure(int airPressure);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletAirQuality(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALL_VALUES)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_TEMPERATURE_OFFSET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TEMPERATURE_OFFSET)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_ALL_VALUES_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALL_VALUES_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IAQ_INDEX)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_IAQ_INDEX_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IAQ_INDEX_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_HUMIDITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_HUMIDITY_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_HUMIDITY_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_AIR_PRESSURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_REMOVE_CALIBRATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BACKGROUND_CALIBRATION_DURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BACKGROUND_CALIBRATION_DURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_ALL_VALUES] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int iaqIndex = (bb.getInt());
				int iaqIndexAccuracy = IPConnection.unsignedByte(bb.get());
				int temperature = (bb.getInt());
				int humidity = (bb.getInt());
				int airPressure = (bb.getInt());

				for (AllValuesListener listener: listenerAllValues) {
					listener.allValues(iaqIndex, iaqIndexAccuracy, temperature, humidity, airPressure);
				}
			}
		};

		callbacks[CALLBACK_IAQ_INDEX] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int iaqIndex = (bb.getInt());
				int iaqIndexAccuracy = IPConnection.unsignedByte(bb.get());

				for (IAQIndexListener listener: listenerIAQIndex) {
					listener.iaqIndex(iaqIndex, iaqIndexAccuracy);
				}
			}
		};

		callbacks[CALLBACK_TEMPERATURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int temperature = (bb.getInt());

				for (TemperatureListener listener: listenerTemperature) {
					listener.temperature(temperature);
				}
			}
		};

		callbacks[CALLBACK_HUMIDITY] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int humidity = (bb.getInt());

				for (HumidityListener listener: listenerHumidity) {
					listener.humidity(humidity);
				}
			}
		};

		callbacks[CALLBACK_AIR_PRESSURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int airPressure = (bb.getInt());

				for (AirPressureListener listener: listenerAirPressure) {
					listener.airPressure(airPressure);
				}
			}
		};
	}

	/**
	 * Returns all values measured by the Air Quality Bricklet. The values are
	 * IAQ (Indoor Air Quality) Index (higher value means greater level of air pollution), IAQ Index Accuracy, Temperature, Humidity and
	 * Air Pressure.
	 * 
	 * .. image:: /Images/Misc/bricklet_air_quality_iaq_index.png
	 *    :scale: 100 %
	 *    :alt: Air Quality Index description
	 *    :align: center
	 *    :target: ../../_images/Misc/bricklet_air_quality_iaq_index.png
	 */
	public AllValues getAllValues() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALL_VALUES, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AllValues obj = new AllValues();
		obj.iaqIndex = (bb.getInt());
		obj.iaqIndexAccuracy = IPConnection.unsignedByte(bb.get());
		obj.temperature = (bb.getInt());
		obj.humidity = (bb.getInt());
		obj.airPressure = (bb.getInt());

		return obj;
	}

	/**
	 * Sets a temperature offset. A offset of 10 will decrease the measured temperature by 0.1 °C.
	 * 
	 * If you install this Bricklet into an enclosure and you want to measure the ambient
	 * temperature, you may have to decrease the measured temperature by some value to
	 * compensate for the error because of the heating inside of the enclosure.
	 * 
	 * We recommend that you leave the parts in the enclosure running for at least
	 * 24 hours such that a temperature equilibrium can be reached. After that you can measure
	 * the temperature directly outside of enclosure and set the difference as offset.
	 * 
	 * This temperature offset is used to calculate the relative humidity and
	 * IAQ index measurements. In case the Bricklet is installed in an enclosure, we
	 * recommend to measure and set the temperature offset to imporve the accuracy of
	 * the measurements.
	 */
	public void setTemperatureOffset(int offset) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_TEMPERATURE_OFFSET, this);

		bb.putInt(offset);

		sendRequest(bb.array());
	}

	/**
	 * Returns the temperature offset as set by
	 * {@link BrickletAirQuality#setTemperatureOffset(int)}.
	 */
	public int getTemperatureOffset() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE_OFFSET, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int offset = (bb.getInt());

		return offset;
	}

	/**
	 * The period is the period with which the {@link BrickletAirQuality.AllValuesListener}
	 * listener is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after at least one of the values has changed. If the values didn't
	 * change within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 */
	public void setAllValuesCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_ALL_VALUES_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletAirQuality#setAllValuesCallbackConfiguration(long, boolean)}.
	 */
	public AllValuesCallbackConfiguration getAllValuesCallbackConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALL_VALUES_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AllValuesCallbackConfiguration obj = new AllValuesCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Returns the IAQ index and accuracy. The higher the IAQ index, the greater the level of air pollution.
	 * 
	 * .. image:: /Images/Misc/bricklet_air_quality_iaq_index.png
	 *    :scale: 100 %
	 *    :alt: IAQ index description
	 *    :align: center
	 *    :target: ../../_images/Misc/bricklet_air_quality_iaq_index.png
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletAirQuality.IAQIndexListener} listener. You can set the listener configuration
	 * with {@link BrickletAirQuality#setIAQIndexCallbackConfiguration(long, boolean)}.
	 */
	public IAQIndex getIAQIndex() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IAQ_INDEX, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		IAQIndex obj = new IAQIndex();
		obj.iaqIndex = (bb.getInt());
		obj.iaqIndexAccuracy = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * The period is the period with which the {@link BrickletAirQuality.IAQIndexListener}
	 * listener is triggered periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after at least one of the values has changed. If the values didn't
	 * change within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 */
	public void setIAQIndexCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_IAQ_INDEX_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by
	 * {@link BrickletAirQuality#setIAQIndexCallbackConfiguration(long, boolean)}.
	 */
	public IAQIndexCallbackConfiguration getIAQIndexCallbackConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IAQ_INDEX_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		IAQIndexCallbackConfiguration obj = new IAQIndexCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Returns temperature.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletAirQuality.TemperatureListener} listener. You can set the listener configuration
	 * with {@link BrickletAirQuality#setTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getTemperature() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getInt());

		return temperature;
	}

	/**
	 * The period is the period with which the {@link BrickletAirQuality.TemperatureListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletAirQuality.TemperatureListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 */
	public void setTemperatureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletAirQuality#setTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public TemperatureCallbackConfiguration getTemperatureCallbackConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		TemperatureCallbackConfiguration obj = new TemperatureCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Returns relative humidity.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletAirQuality.HumidityListener} listener. You can set the listener configuration
	 * with {@link BrickletAirQuality#setHumidityCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getHumidity() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_HUMIDITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int humidity = (bb.getInt());

		return humidity;
	}

	/**
	 * The period is the period with which the {@link BrickletAirQuality.HumidityListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletAirQuality.HumidityListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 */
	public void setHumidityCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_HUMIDITY_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletAirQuality#setHumidityCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public HumidityCallbackConfiguration getHumidityCallbackConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_HUMIDITY_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		HumidityCallbackConfiguration obj = new HumidityCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Returns air pressure.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletAirQuality.AirPressureListener} listener. You can set the listener configuration
	 * with {@link BrickletAirQuality#setAirPressureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getAirPressure() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AIR_PRESSURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int airPressure = (bb.getInt());

		return airPressure;
	}

	/**
	 * The period is the period with which the {@link BrickletAirQuality.AirPressureListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletAirQuality.AirPressureListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 */
	public void setAirPressureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletAirQuality#setAirPressureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public AirPressureCallbackConfiguration getAirPressureCallbackConfiguration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AirPressureCallbackConfiguration obj = new AirPressureCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Deletes the calibration from flash. After you call this function,
	 * you need to power cycle the Air Quality Bricklet.
	 * 
	 * On the next power up the Bricklet will start a new calibration, as
	 * if it was started for the very first time.
	 * 
	 * The calibration is based on the data of the last four days, so it takes
	 * four days until a full calibration is re-established.
	 * 
	 * .. versionadded:: 2.0.3$nbsp;(Plugin)
	 */
	public void removeCalibration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_REMOVE_CALIBRATION, this);


		sendRequest(bb.array());
	}

	/**
	 * The Air Quality Bricklet uses an automatic background calibration mechanism to
	 * calculate the IAQ Index. This calibration mechanism considers a history of
	 * measured data. The duration of this history can be configured to either be
	 * 4 days or 28 days.
	 * 
	 * If you keep the Bricklet mostly at one place and it does not get moved around
	 * to different environments, we recommend that you use a duration of 28 days.
	 * 
	 * If you change the duration, the current calibration will be discarded and
	 * the calibration will start from beginning again. The configuration of the
	 * duration is saved in flash, so you should only have to call this function
	 * once in the lifetime of the Bricklet.
	 * 
	 * The Bricklet has to be power cycled after this function is called
	 * for a duration change to take effect.
	 * 
	 * Before firmware version 2.0.3 this was not configurable and the duration was
	 * 4 days.
	 * 
	 * The default value (since firmware version 2.0.3) is 28 days.
	 * 
	 * .. versionadded:: 2.0.3$nbsp;(Plugin)
	 */
	public void setBackgroundCalibrationDuration(int duration) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BACKGROUND_CALIBRATION_DURATION, this);

		bb.put((byte)duration);

		sendRequest(bb.array());
	}

	/**
	 * Returns the background calibration duration as set by
	 * {@link BrickletAirQuality#setBackgroundCalibrationDuration(int)}.
	 * 
	 * .. versionadded:: 2.0.3$nbsp;(Plugin)
	 */
	public int getBackgroundCalibrationDuration() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BACKGROUND_CALIBRATION_DURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int duration = IPConnection.unsignedByte(bb.get());

		return duration;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletAirQuality#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletAirQuality#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletAirQuality#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletAirQuality#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a AllValues listener.
	 */
	public void addAllValuesListener(AllValuesListener listener) {
		listenerAllValues.add(listener);
	}

	/**
	 * Removes a AllValues listener.
	 */
	public void removeAllValuesListener(AllValuesListener listener) {
		listenerAllValues.remove(listener);
	}

	/**
	 * Adds a IAQIndex listener.
	 */
	public void addIAQIndexListener(IAQIndexListener listener) {
		listenerIAQIndex.add(listener);
	}

	/**
	 * Removes a IAQIndex listener.
	 */
	public void removeIAQIndexListener(IAQIndexListener listener) {
		listenerIAQIndex.remove(listener);
	}

	/**
	 * Adds a Temperature listener.
	 */
	public void addTemperatureListener(TemperatureListener listener) {
		listenerTemperature.add(listener);
	}

	/**
	 * Removes a Temperature listener.
	 */
	public void removeTemperatureListener(TemperatureListener listener) {
		listenerTemperature.remove(listener);
	}

	/**
	 * Adds a Humidity listener.
	 */
	public void addHumidityListener(HumidityListener listener) {
		listenerHumidity.add(listener);
	}

	/**
	 * Removes a Humidity listener.
	 */
	public void removeHumidityListener(HumidityListener listener) {
		listenerHumidity.remove(listener);
	}

	/**
	 * Adds a AirPressure listener.
	 */
	public void addAirPressureListener(AirPressureListener listener) {
		listenerAirPressure.add(listener);
	}

	/**
	 * Removes a AirPressure listener.
	 */
	public void removeAirPressureListener(AirPressureListener listener) {
		listenerAirPressure.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletAirQuality.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletAirQuality.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletAirQualityConfig cfg = (BrickletAirQualityConfig) config.as(BrickletAirQualityConfig.class);
        this.addHumidityListener((humidity) -> {if(true) {updateStateFn.accept("BrickletAirQualityHumidity", transformBrickletAirQualityHumidityCallback0(humidity, cfg));}});
		this.addTemperatureListener((temperature) -> {if(true) {updateStateFn.accept("BrickletAirQualityTemperature", transformBrickletAirQualityTemperatureCallback0(temperature, cfg));}});
		this.addAirPressureListener((airPressure) -> {if(true) {updateStateFn.accept("BrickletAirQualityAirPressure", transformBrickletAirQualityAirPressureCallback0(airPressure, cfg));}});
		this.addIAQIndexListener((iaqIndex, iaqIndexAccuracy) -> {if(true) {updateStateFn.accept("BrickletAirQualityIAQIndex", transformBrickletAirQualityIAQIndexCallback0(iaqIndex, iaqIndexAccuracy, cfg));}});
		this.addIAQIndexListener((iaqIndex, iaqIndexAccuracy) -> {if(true) {updateStateFn.accept("BrickletAirQualityIAQIndexAccuracy", transformBrickletAirQualityIAQIndexAccuracyCallback0(iaqIndex, iaqIndexAccuracy, cfg));}});
        this.setTemperatureOffset((int)(cfg.temperatureOffset.doubleValue() * 100.0f));
		        this.setIAQIndexCallbackConfiguration(cfg.iaqIndexUpdateInterval, true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletAirQualityHumidityConfig channelCfg = getChannelConfigFn.apply("BrickletAirQualityHumidity").as(BrickletAirQualityHumidityConfig.class);
		this.setHumidityCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletAirQualityTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletAirQualityTemperature").as(BrickletAirQualityTemperatureConfig.class);
		this.setTemperatureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletAirQualityAirPressureConfig channelCfg = getChannelConfigFn.apply("BrickletAirQualityAirPressure").as(BrickletAirQualityAirPressureConfig.class);
		this.setAirPressureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletAirQualityIAQIndexConfig channelCfg = getChannelConfigFn.apply("BrickletAirQualityIAQIndex").as(BrickletAirQualityIAQIndexConfig.class);
		
		}
		{
		BrickletAirQualityIAQIndexAccuracyConfig channelCfg = getChannelConfigFn.apply("BrickletAirQualityIAQIndexAccuracy").as(BrickletAirQualityIAQIndexAccuracyConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletAirQualityConfig cfg = (BrickletAirQualityConfig) config.as(BrickletAirQualityConfig.class);
        this.listenerHumidity.clear();
		this.listenerTemperature.clear();
		this.listenerAirPressure.clear();
		this.listenerIAQIndex.clear();
		this.listenerIAQIndex.clear();
        this.setHumidityCallbackConfiguration(0, true, 'x', 0, 0);
		this.setTemperatureCallbackConfiguration(0, true, 'x', 0, 0);
		this.setAirPressureCallbackConfiguration(0, true, 'x', 0, 0);
		
		
		this.setIAQIndexCallbackConfiguration(0, true);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletAirQualityConfig cfg = (BrickletAirQualityConfig) config.as(BrickletAirQualityConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletAirQualityHumidity");
		result.add("BrickletAirQualityTemperature");
		result.add("BrickletAirQualityAirPressure");
		result.add("BrickletAirQualityIAQIndex");
		result.add("BrickletAirQualityIAQIndexAccuracy");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletAirQualityHumidity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAirQualityHumidity"), "Humidity", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAirQualityHumidity")).withDescription("Measured relative humidity")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(100)).withPattern("%.2f %%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletAirQualityTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAirQualityTemperature"), "Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAirQualityTemperature")).withDescription("Measured temperature")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-40)).withMaximum(BigDecimal.valueOf(85)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletAirQualityAirPressure":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAirQualityAirPressure"), "Air Pressure", "Number:Pressure").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAirQualityAirPressure")).withDescription("Measured air pressure")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(300)).withMaximum(BigDecimal.valueOf(1100)).withPattern("%.5f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletAirQualityIAQIndex":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAirQualityIAQIndex"), "IAQ Index", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAirQualityIAQIndex")).withDescription("The IAQ index goes from 0 to 500. The higher the IAQ index, the greater the level of air pollution.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(500)).withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletAirQualityIAQIndexAccuracy":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAirQualityIAQIndexAccuracy"), "IAQ Index Accuracy", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAirQualityIAQIndexAccuracy")).withDescription("The Bricklet is building a database of measurements and uses this data to do an automatic background calibration and calculate an accurate IAQ index over time. It will take a few days until the IAQ index has a high reliability.<br/><br/>The IAQ accuracy is reflects the current state of the background calibration process.<br/><br/>    Accuracy 0: The Bricklet was just started and the sensor is stabilizing.<br/>    Accuracy 1: The background history is uncertain. This typically means the gas sensor data was too stable for the calibration algorithm to clearly define its references.<br/>    Accuracy 2: The Bricklet found new calibration data and is currently calibrating.<br/>    Accuracy 3: The Bricklets is calibrated successfully.<br/><br/>The effective duration of the calibration process depends on the stimuli observed by the sensor. An IAQ accuracy going back and fourth between 2 and 3 is expected, the Bricklet is recalibrating itself.<br/><br/>The Bricklet saves the current database of values and calculated coefficients every 12 hours in its internal flash memory. If the Bricklet loses power it will not take as long to receive reliable data again.<br/><br/>Starting with firmware version 2.0.3 the automatic background calibration considers 28 days of data. We recommend that you run the Bricklet for 28 full days before you consider the data as completely reliable. It is possible to reduce the calibration window to 4 days with the API.<br/><br/><br/>Note<br/><br/>The currently released firmware (2.0.4) does not save the calibration every 12 hours. We had to disable this because of a bug in the proprietary load/save mechanism that we can't fix. We will release a new firmware that has this enabled again as soon as this bug is fixed.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(500)).withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Air Quality Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures IAQ index, temperature, humidity and air pressure").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletAirQualityHumidity", new ChannelTypeUID("tinkerforge", "BrickletAirQualityHumidity")).withLabel("Humidity").build(), new ChannelDefinitionBuilder("BrickletAirQualityTemperature", new ChannelTypeUID("tinkerforge", "BrickletAirQualityTemperature")).withLabel("Temperature").build(), new ChannelDefinitionBuilder("BrickletAirQualityAirPressure", new ChannelTypeUID("tinkerforge", "BrickletAirQualityAirPressure")).withLabel("Air Pressure").build(), new ChannelDefinitionBuilder("BrickletAirQualityIAQIndex", new ChannelTypeUID("tinkerforge", "BrickletAirQualityIAQIndex")).withLabel("IAQ Index").build(), new ChannelDefinitionBuilder("BrickletAirQualityIAQIndexAccuracy", new ChannelTypeUID("tinkerforge", "BrickletAirQualityIAQIndexAccuracy")).withLabel("IAQ Index Accuracy").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletairquality":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("temperatureOffset", Type.DECIMAL).withDefault("0").withDescription("If you install this Bricklet into an enclosure and you want to measure the ambient temperature, you may have to decrease the measured temperature by some value to compensate for the error because of the heating inside of the enclosure.<br/><br/>We recommend that you leave the parts in the enclosure running for at least 24 hours such that a temperature equilibrium can be reached. After that you can measure the temperature directly outside of enclosure and set the difference as offset.<br/><br/>This temperature offset is used to calculate the relative humidity and IAQ index measurements. In case the Bricklet is installed in an enclosure, we recommend to measure and set the temperature offset to imporve the accuracy of the measurements.").withLabel("Temperature Offset").build(), ConfigDescriptionParameterBuilder.create("iaqIndexUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the IAQ index and accuracy in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("IAQ Index Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletAirQualityHumidity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletAirQualityTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletAirQualityAirPressure":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletAirQualityIAQIndex":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletAirQualityIAQIndexAccuracy":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletAirQualityConfig cfg = (BrickletAirQualityConfig) config.as(BrickletAirQualityConfig.class);
        switch(channel) {
            case "BrickletAirQualityHumidity": {
                   BrickletAirQualityHumidityConfig channelCfg = channelConfig.as(BrickletAirQualityHumidityConfig.class);
                   {
            int value = this.getHumidity();
            if(true)
                updateStateFn.accept(channel, transformBrickletAirQualityHumidityGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletAirQualityTemperature": {
                   BrickletAirQualityTemperatureConfig channelCfg = channelConfig.as(BrickletAirQualityTemperatureConfig.class);
                   {
            int value = this.getTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletAirQualityTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletAirQualityAirPressure": {
                   BrickletAirQualityAirPressureConfig channelCfg = channelConfig.as(BrickletAirQualityAirPressureConfig.class);
                   {
            int value = this.getAirPressure();
            if(true)
                updateStateFn.accept(channel, transformBrickletAirQualityAirPressureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletAirQualityIAQIndex": {
                   BrickletAirQualityIAQIndexConfig channelCfg = channelConfig.as(BrickletAirQualityIAQIndexConfig.class);
                   {
            IAQIndex value = this.getIAQIndex();
            if(true)
                updateStateFn.accept(channel, transformBrickletAirQualityIAQIndexGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletAirQualityIAQIndexAccuracy": {
                   BrickletAirQualityIAQIndexAccuracyConfig channelCfg = channelConfig.as(BrickletAirQualityIAQIndexAccuracyConfig.class);
                   {
            IAQIndex value = this.getIAQIndex();
            if(true)
                updateStateFn.accept(channel, transformBrickletAirQualityIAQIndexAccuracyGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletAirQualityConfig cfg = (BrickletAirQualityConfig) config.as(BrickletAirQualityConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletAirQualityHumidityCallback0(int humidity, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(humidity / 100.0, SmartHomeUnits.PERCENT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityTemperatureCallback0(int temperature, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(temperature / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityAirPressureCallback0(int airPressure, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(airPressure / 100000.0, SmartHomeUnits.BAR);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityIAQIndexCallback0(int iaqIndex, int iaqIndexAccuracy, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(iaqIndex, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityIAQIndexAccuracyCallback0(int iaqIndex, int iaqIndexAccuracy, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(iaqIndexAccuracy, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityHumidityGetter0(int value, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(value / 100.0, SmartHomeUnits.PERCENT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityTemperatureGetter0(int value, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(value / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityAirPressureGetter0(int value, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(value / 100000.0, SmartHomeUnits.BAR);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityIAQIndexGetter0(IAQIndex value, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(value.iaqIndex, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityIAQIndexAccuracyGetter0(IAQIndex value, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(value.iaqIndexAccuracy, SmartHomeUnits.ONE);
    }
}
