/* ***********************************************************
 * This file was automatically generated on 2020-01-22.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

/**
 * Measures two DC currents between 0mA and 20mA (IEC 60381-1)
 */
public class BrickletIndustrialDual020mAV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2120;
	public final static String DEVICE_DISPLAY_NAME = "Industrial Dual 0-20mA Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletindustrialdual020mav2", DEVICE_IDENTIFIER, BrickletIndustrialDual020mAV2.class, BrickletIndustrialDual020mAV2Actions.class, "2.0.1");

	public final static byte FUNCTION_GET_CURRENT = (byte)1;
	public final static byte FUNCTION_SET_CURRENT_CALLBACK_CONFIGURATION = (byte)2;
	public final static byte FUNCTION_GET_CURRENT_CALLBACK_CONFIGURATION = (byte)3;
	public final static byte FUNCTION_SET_SAMPLE_RATE = (byte)5;
	public final static byte FUNCTION_GET_SAMPLE_RATE = (byte)6;
	public final static byte FUNCTION_SET_GAIN = (byte)7;
	public final static byte FUNCTION_GET_GAIN = (byte)8;
	public final static byte FUNCTION_SET_CHANNEL_LED_CONFIG = (byte)9;
	public final static byte FUNCTION_GET_CHANNEL_LED_CONFIG = (byte)10;
	public final static byte FUNCTION_SET_CHANNEL_LED_STATUS_CONFIG = (byte)11;
	public final static byte FUNCTION_GET_CHANNEL_LED_STATUS_CONFIG = (byte)12;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_CURRENT = 4;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int SAMPLE_RATE_240_SPS = 0;
	public final static int SAMPLE_RATE_60_SPS = 1;
	public final static int SAMPLE_RATE_15_SPS = 2;
	public final static int SAMPLE_RATE_4_SPS = 3;
	public final static int GAIN_1X = 0;
	public final static int GAIN_2X = 1;
	public final static int GAIN_4X = 2;
	public final static int GAIN_8X = 3;
	public final static int CHANNEL_LED_CONFIG_OFF = 0;
	public final static int CHANNEL_LED_CONFIG_ON = 1;
	public final static int CHANNEL_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int CHANNEL_LED_CONFIG_SHOW_CHANNEL_STATUS = 3;
	public final static int CHANNEL_LED_STATUS_CONFIG_THRESHOLD = 0;
	public final static int CHANNEL_LED_STATUS_CONFIG_INTENSITY = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<CurrentListener> listenerCurrent = new CopyOnWriteArrayList<CurrentListener>();

	public class CurrentCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class ChannelLEDStatusConfig {
		public int min;
		public int max;
		public int config;

		public String toString() {
			return "[" + "min = " + min + ", " + "max = " + max + ", " + "config = " + config + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletIndustrialDual020mAV2#setCurrentCallbackConfiguration(int, long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletIndustrialDual020mAV2#getCurrent(int)}.
	 */
	public interface CurrentListener extends DeviceListener {
		public void current(int channel, int current);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIndustrialDual020mAV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CURRENT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CURRENT_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CURRENT_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SAMPLE_RATE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SAMPLE_RATE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_GAIN)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_GAIN)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CHANNEL_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHANNEL_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CHANNEL_LED_STATUS_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHANNEL_LED_STATUS_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_CURRENT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int channel = IPConnection.unsignedByte(bb.get());
				int current = (bb.getInt());

				for (CurrentListener listener: listenerCurrent) {
					listener.current(channel, current);
				}
			}
		};
	}

	/**
	 * Returns the current of the specified channel.
	 * 
	 * It is possible to detect if an IEC 60381-1 compatible sensor is connected
	 * and if it works probably.
	 * 
	 * If the returned current is below 4mA, there is likely no sensor connected
	 * or the connected sensor is defective. If the returned current is over 20mA,
	 * there might be a short circuit or the sensor is defective.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletIndustrialDual020mAV2.CurrentListener} listener. You can set the listener configuration
	 * with {@link BrickletIndustrialDual020mAV2#setCurrentCallbackConfiguration(int, long, boolean, char, int, int)}.
	 */
	public int getCurrent(int channel) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CURRENT, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int current = (bb.getInt());

		return current;
	}

	/**
	 * The period is the period with which the {@link BrickletIndustrialDual020mAV2.CurrentListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletIndustrialDual020mAV2.CurrentListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 */
	public void setCurrentCallbackConfiguration(int channel, long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)23, FUNCTION_SET_CURRENT_CALLBACK_CONFIGURATION, this);

		bb.put((byte)channel);
		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletIndustrialDual020mAV2#setCurrentCallbackConfiguration(int, long, boolean, char, int, int)}.
	 */
	public CurrentCallbackConfiguration getCurrentCallbackConfiguration(int channel) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CURRENT_CALLBACK_CONFIGURATION, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		CurrentCallbackConfiguration obj = new CurrentCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the sample rate to either 240, 60, 15 or 4 samples per second.
	 * The resolution for the rates is 12, 14, 16 and 18 bit respectively.
	 * 
	 * \verbatim
	 *  "Value", "Description"
	 * 
	 *  "0",    "240 samples per second, 12 bit resolution"
	 *  "1",    "60 samples per second, 14 bit resolution"
	 *  "2",    "15 samples per second, 16 bit resolution"
	 *  "3",    "4 samples per second, 18 bit resolution"
	 * \endverbatim
	 */
	public void setSampleRate(int rate) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_SAMPLE_RATE, this);

		bb.put((byte)rate);

		sendRequest(bb.array());
	}

	/**
	 * Returns the gain as set by {@link BrickletIndustrialDual020mAV2#setSampleRate(int)}.
	 */
	public int getSampleRate() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SAMPLE_RATE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int rate = IPConnection.unsignedByte(bb.get());

		return rate;
	}

	/**
	 * Sets a gain between 1x and 8x. If you want to measure a very small current,
	 * you can increase the gain to get some more resolution.
	 * 
	 * Example: If you measure 0.5mA with a gain of 8x the return value will be
	 * 4mA.
	 */
	public void setGain(int gain) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_GAIN, this);

		bb.put((byte)gain);

		sendRequest(bb.array());
	}

	/**
	 * Returns the gain as set by {@link BrickletIndustrialDual020mAV2#setGain(int)}.
	 */
	public int getGain() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_GAIN, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int gain = IPConnection.unsignedByte(bb.get());

		return gain;
	}

	/**
	 * Each channel has a corresponding LED. You can turn the LED off, on or show a
	 * heartbeat. You can also set the LED to "Channel Status". In this mode the
	 * LED can either be turned on with a pre-defined threshold or the intensity
	 * of the LED can change with the measured value.
	 * 
	 * You can configure the channel status behavior with {@link BrickletIndustrialDual020mAV2#setChannelLEDStatusConfig(int, int, int, int)}.
	 */
	public void setChannelLEDConfig(int channel, int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CHANNEL_LED_CONFIG, this);

		bb.put((byte)channel);
		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the channel LED configuration as set by {@link BrickletIndustrialDual020mAV2#setChannelLEDConfig(int, int)}
	 */
	public int getChannelLEDConfig(int channel) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CHANNEL_LED_CONFIG, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Sets the channel LED status config. This config is used if the channel LED is
	 * configured as "Channel Status", see {@link BrickletIndustrialDual020mAV2#setChannelLEDConfig(int, int)}.
	 * 
	 * For each channel you can choose between threshold and intensity mode.
	 * 
	 * In threshold mode you can define a positive or a negative threshold.
	 * For a positive threshold set the "min" parameter to the threshold value in nA
	 * above which the LED should turn on and set the "max" parameter to 0. Example:
	 * If you set a positive threshold of 10mA, the LED will turn on as soon as the
	 * current exceeds 10mA and turn off again if it goes below 10mA.
	 * For a negative threshold set the "max" parameter to the threshold value in nA
	 * below which the LED should turn on and set the "min" parameter to 0. Example:
	 * If you set a negative threshold of 10mA, the LED will turn on as soon as the
	 * current goes below 10mA and the LED will turn off when the current exceeds 10mA.
	 * 
	 * In intensity mode you can define a range in nA that is used to scale the brightness
	 * of the LED. Example with min=4mA and max=20mA: The LED is off at 4mA and below,
	 * on at 20mA and above and the brightness is linearly scaled between the values
	 * 4mA and 20mA. If the min value is greater than the max value, the LED brightness
	 * is scaled the other way around.
	 */
	public void setChannelLEDStatusConfig(int channel, int min, int max, int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)18, FUNCTION_SET_CHANNEL_LED_STATUS_CONFIG, this);

		bb.put((byte)channel);
		bb.putInt(min);
		bb.putInt(max);
		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the channel LED status configuration as set by
	 * {@link BrickletIndustrialDual020mAV2#setChannelLEDStatusConfig(int, int, int, int)}.
	 */
	public ChannelLEDStatusConfig getChannelLEDStatusConfig(int channel) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CHANNEL_LED_STATUS_CONFIG, this);

		bb.put((byte)channel);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ChannelLEDStatusConfig obj = new ChannelLEDStatusConfig();
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());
		obj.config = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletIndustrialDual020mAV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletIndustrialDual020mAV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletIndustrialDual020mAV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletIndustrialDual020mAV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		checkDeviceIdentifier();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Current listener.
	 */
	public void addCurrentListener(CurrentListener listener) {
		listenerCurrent.add(listener);
	}

	/**
	 * Removes a Current listener.
	 */
	public void removeCurrentListener(CurrentListener listener) {
		listenerCurrent.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialDual020mAV2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialDual020mAV2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDual020mAV2Config cfg = (BrickletIndustrialDual020mAV2Config) config.as(BrickletIndustrialDual020mAV2Config.class);
        this.addCurrentListener((channel, current) -> {if(channel == 0) {updateStateFn.accept("BrickletIndustrialDual020mAV2CurrentSensor0", transformBrickletIndustrialDual020mAV2CurrentSensor0Callback0(channel, current, cfg));}});
		this.addCurrentListener((channel, current) -> {if(channel == 1) {updateStateFn.accept("BrickletIndustrialDual020mAV2CurrentSensor1", transformBrickletIndustrialDual020mAV2CurrentSensor1Callback0(channel, current, cfg));}});
        this.setSampleRate(cfg.sampleRate);
		    this.setGain(cfg.gain);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletIndustrialDual020mAV2CurrentConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDual020mAV2CurrentSensor0").as(BrickletIndustrialDual020mAV2CurrentConfig.class);
		this.setCurrentCallbackConfiguration(0, channelCfg.updateInterval, true, 'x', 0, 0);
		            this.setChannelLEDConfig(0, channelCfg.ledConfig);
		            this.setChannelLEDStatusConfig(0, channelCfg.ledStatusMinimum, channelCfg.ledStatusMaximum, channelCfg.ledStatusMode);
		}
		{
		BrickletIndustrialDual020mAV2CurrentConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDual020mAV2CurrentSensor1").as(BrickletIndustrialDual020mAV2CurrentConfig.class);
		this.setCurrentCallbackConfiguration(1, channelCfg.updateInterval, true, 'x', 0, 0);
		            this.setChannelLEDConfig(1, channelCfg.ledConfig);
		            this.setChannelLEDStatusConfig(1, channelCfg.ledStatusMinimum, channelCfg.ledStatusMaximum, channelCfg.ledStatusMode);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIndustrialDual020mAV2Config cfg = (BrickletIndustrialDual020mAV2Config) config.as(BrickletIndustrialDual020mAV2Config.class);
        this.listenerCurrent.clear();
		this.listenerCurrent.clear();
        this.setCurrentCallbackConfiguration(0, 0, true, 'x', 0, 0);
		this.setCurrentCallbackConfiguration(1, 0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialDual020mAV2Config cfg = (BrickletIndustrialDual020mAV2Config) config.as(BrickletIndustrialDual020mAV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialDual020mAV2CurrentSensor0");
		result.add("BrickletIndustrialDual020mAV2CurrentSensor1");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialDual020mAV2Current":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mAV2Current"), "NOT USED", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialDual020mAV2Current")).withDescription("Measured current between 0 and 0.022505322A (22.5mA)")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(0.022505322)).withPattern("%.6f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Dual 0-20mA Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures two DC currents between 0mA and 20mA (IEC 60381-1)").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialDual020mAV2CurrentSensor0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mAV2Current")).withLabel("Current Sensor 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialDual020mAV2CurrentSensor1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mAV2Current")).withLabel("Current Sensor 1").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialdual020mav2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("sampleRate", Type.INTEGER).withDefault("3").withDescription("The sample rate to either 240, 60, 15 or 4 samples per second. The resolution for the rates is 12, 14, 16 and 18 bit respectively.").withLabel("Sample Rate").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "240 SPS"), new ParameterOption("1", "60 SPS"), new ParameterOption("2", "15 SPS"), new ParameterOption("3", "4 SPS"))).build(), ConfigDescriptionParameterBuilder.create("gain", Type.INTEGER).withDefault("0").withDescription("The gain between 1x and 8x. If you want to measure a very small current, you can increase the gain to get some more resolution.<br/><br/>Example: If you measure 0.5mA with a gain of 8x the return value will be 4mA.").withLabel("Gain").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "1x"), new ParameterOption("1", "2x"), new ParameterOption("2", "4x"), new ParameterOption("3", "8x"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletIndustrialDual020mAV2Current":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("ledConfig", Type.INTEGER).withDefault("3").withDescription("Each channel has a corresponding LED. You can turn the LED off, on or show a heartbeat. You can also set the LED to Show Channel Status. In this mode the LED can either be turned on with a pre-defined threshold or the intensity of the LED can change with the measured value.").withLabel("LED Configuration").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Channel Status"))).build(), ConfigDescriptionParameterBuilder.create("ledStatusMode", Type.INTEGER).withDefault("1").withDescription("For each channel you can choose between threshold and intensity mode.<br/><br/>In threshold mode you can define a positive or a negative threshold.<br/>For a positive threshold set the \"min\" parameter to the threshold value in nA<br/>above which the LED should turn on and set the \"max\" parameter to 0. Example:<br/>If you set a positive threshold of 10mA, the LED will turn on as soon as the<br/>current exceeds 10mA and turn off again if it goes below 10mA.<br/>For a negative threshold set the \"max\" parameter to the threshold value in nA<br/>below which the LED should turn on and set the \"min\" parameter to 0. Example:<br/>If you set a negative threshold of 10mA, the LED will turn on as soon as the<br/>current goes below 10mA and the LED will turn off when the current exceeds 10mA.<br/><br/>In intensity mode you can define a range in nA that is used to scale the brightness<br/>of the LED. Example with min=4mA and max=20mA: The LED is off at 4mA and below,<br/>on at 20mA and above and the brightness is linearly scaled between the values<br/>4mA and 20mA. If the min value is greater than the max value, the LED brightness<br/>is scaled the other way around.").withLabel("LED Status Mode").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Threshold"), new ParameterOption("1", "Intensity"))).build(), ConfigDescriptionParameterBuilder.create("ledStatusMinimum", Type.INTEGER).withDefault("0").withDescription("See LED Status Mode for further explaination.").withLabel("LED Status Maximum").withUnit("V").withMinimum(BigDecimal.valueOf(-35)).withMaximum(BigDecimal.valueOf(35)).build(), ConfigDescriptionParameterBuilder.create("ledStatusMaximum", Type.INTEGER).withDefault("10").withDescription("See LED Status Mode for further explaination.").withLabel("LED Status Maximum").withUnit("V").withMinimum(BigDecimal.valueOf(-35)).withMaximum(BigDecimal.valueOf(35)).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDual020mAV2Config cfg = (BrickletIndustrialDual020mAV2Config) config.as(BrickletIndustrialDual020mAV2Config.class);
        switch(channel) {
            case "BrickletIndustrialDual020mAV2CurrentSensor0": {
                   BrickletIndustrialDual020mAV2CurrentConfig channelCfg = channelConfig.as(BrickletIndustrialDual020mAV2CurrentConfig.class);
                   {
            int value = this.getCurrent(0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDual020mAV2CurrentSensor0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDual020mAV2CurrentSensor1": {
                   BrickletIndustrialDual020mAV2CurrentConfig channelCfg = channelConfig.as(BrickletIndustrialDual020mAV2CurrentConfig.class);
                   {
            int value = this.getCurrent(1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDual020mAV2CurrentSensor1Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletIndustrialDual020mAV2Config cfg = (BrickletIndustrialDual020mAV2Config) config.as(BrickletIndustrialDual020mAV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mAV2CurrentSensor0Callback0(int channel, int current, BrickletIndustrialDual020mAV2Config cfg) {
        return new QuantityType<>(current / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mAV2CurrentSensor1Callback0(int channel, int current, BrickletIndustrialDual020mAV2Config cfg) {
        return new QuantityType<>(current / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mAV2CurrentSensor0Getter0(int value, BrickletIndustrialDual020mAV2Config cfg) {
        return new QuantityType<>(value / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mAV2CurrentSensor1Getter0(int value, BrickletIndustrialDual020mAV2Config cfg) {
        return new QuantityType<>(value / 1000000000.0, SmartHomeUnits.AMPERE);
    }
}
